{"revision":"c10276e953456835cdbb1f3a60d58ae1980be353","document":{"id":486,"path":"api-reference/rest-apis/changesets-api.md","title":"CdmChangesetsApi","bundle":null,"doc_type":null,"release":"australia","body":"\n# CdmChangesetsApi\n\nThe CdmChangesetsApi provides endpoints that enable you to manage changesets.\n\nUsing these endpoints you can:\n\n-   Create new changesets.\n-   Deploy changesets.\n-   Retrieve lists of or individual changesets.\n-   Retrieves the node changes within a changeset.\n-   Retrieve a list of applications or deployables that are impacted by a changeset.\n-   Delete changesets.\n-   Return a list of shared components that are associated with a specified changeset.\n\nThe create changesets endpoints use an asynchronous queuing implementation. With this type of implementation, you first call the create changeset request endpoint. This endpoint queues your request and returns a commit identifier. You then use this commit identifier to call the appropriate status endpoint to obtain the status of the create request.\n\nYou must have one of the following roles to access this API:\n\n-   Scripted REST CDM View ACL \\(sn\\_cdm.cdm.viewer\\)\n-   Scripted REST CDM Editor ACL \\(sn\\_cdm.cdm\\_editor\\)\n\nIn addition, the Configuration Data Management \\(CDM\\) plugin must be activated for this API to be available in an instance.\n\nFor additional information on changesets, see [Changesets and version control in CDM](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/it-service-management/cdm-changesets-version-control.md).\n\n**Parent Topic:**[REST API reference](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-apis/api-rest.md)\n\n## CdmChangesetsApi - DELETE /sn\\_cdm/changesets\n\nDeletes a specified changeset.\n\nThe caller must have the CDM Editor role to access this endpoint.\n\n### URL format\n\nVersioned URL: `/api/sn_cdm/{api_version}/changesets`\n\nDefault URL: `/api/sn_cdm/changesets`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr></tbody>\n</table><table class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nchangesetNumber\n\n</td><td id=\"changesetNumber-changeset-entry\">\n\nRequired. Unique identifier of the associated changeset, such as \"Chset-10\".\n\nData type: String\n\nTable: CDM Changeset \\[sn\\_cdm\\_changeset\\]\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Header|Description|\n|------|-----------|\n|Accept|Data format of the response body. Only supports **application/json**.|\n\n|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Successful. The request was successfully processed.|\n|400|Bad Request. A bad request type or malformed request was detected.|\n|500|Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.|\n\n### Response body parameters\n\n|Name|Description|\n|----|-----------|\n|None||\n\n### cURL request\n\nThe following code example shows how to remove a changeset.\n\n```\ncurl \"http://instance.servicenow.com/api/sn_cdm/changesets?changesetNumber=Chset-760\" \\ \n--request DELETE \\ \n--header \"Accept:application/json\" \\ \n--user 'username':'password'\n```\n\nFor a successful deletion of the changeset, no response is returned other than the HTTP status code.\n\n```\nNone - results defined by the HTTP status code\n```\n\n## CdmChangesetsApi - GET /sn\\_cdm/changesets\n\nRetrieves all changesets associated with a Configuration Data Management \\(CDM\\) application or a specified changeset record.\n\n### URL format\n\nVersioned URL: `/api/sn_cdm/{api_version}/changesets`\n\nDefault URL: `/api/sn_cdm/changesets`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr></tbody>\n</table><table class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nappName\n\n</td><td>\n\nRequired. Name of the CDM application whose changesets you want returned. This must be an active application.Data type: String\n\nTable: CDM Application \\[sn\\_cdm\\_application\\]\n\n</td></tr><tr><td>\n\nnumber\n\n</td><td>\n\nChangeset number.If you pass this value, only the specified changeset is returned. It must be a changeset that is associated with the CDM application specified in the **appName** parameter.\n\nData type: String\n\nDefault: None - return all changesets associated with the CDM application or the ones specified by the **state** parameter.\n\nTable: CDMChangeset \\[sn\\_cdm\\_changeset\\]\n\n</td></tr><tr><td>\n\nstate\n\n</td><td>\n\nState of the changesets to return. Only return the changesets associated with the specified CDM application for the specified state.Valid values:\n\n-   Blocked\n-   Checking for conflict\n-   Commit failed\n-   Commit in progress\n-   Committed\n-   Open\n\nData type: String\n\nDefault: Return all changesets for all states\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Header|Description|\n|------|-----------|\n|Accept|Data format of the response body. Only supports **application/json**.|\n\n|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Successful. The request was successfully processed.|\n|400|Bad Request. A bad request type or malformed request was detected.|\n|500|Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.|\n\n### Response body parameters\n\n<table><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr id=\"cdm_apps-autoValidate-row\"><td>\n\nauto\\_validate\n\n</td><td>\n\nFlag that indicates whether the changesets created upon commit are validated.Valid values:\n\n-   true: Validate the changesets.\n-   false: Don't validate the changesets.\n\nData type: Boolean\n\n</td></tr><tr><td>\n\ncdm\\_application\n\n</td><td>\n\nDetails of the CDM application associated with the changeset. Data type: Object\n\n```\n\"cdm_application\": {\n  \"link\": \"String\",\n  \"value\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\ncdm\\_application.link\n\n</td><td>\n\nQuery to use to call the Table REST endpoint to retrieve the associated CDM application.Data type: String\n\n</td></tr><tr><td>\n\ncdm\\_application.value\n\n</td><td>\n\nSys\\_id of the associated CDM application.Data type: String\n\nTable: CDM Application \\[sn\\_cdm\\_application\\]\n\n</td></tr><tr><td>\n\ncommitted\\_at\n\n</td><td id=\"committed_at-changeset-entry\">\n\nDate and time that the changeset was last committed.Data type: String\n\nFormat: YYYY-mm-DD hh:mm:ss\n\n</td></tr><tr><td>\n\ncommitted\\_by\n\n</td><td>\n\nDetails about the user that committed the changeset.Data type: Object\n\n```\n\"committed_by\": {\n  \"link\": \"String\",\n  \"value\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\ncommitted\\_by.link\n\n</td><td>\n\nCall to obtain the record of the user that committed the changeset using the REST Table API.Data type: String\n\n</td></tr><tr><td>\n\ncommitted\\_by.value\n\n</td><td>\n\nSys\\_id of the user who committed the changeset.Data type: String\n\n</td></tr><tr><td>\n\ndescription\n\n</td><td>\n\nBrief description of the purpose of the changeset.Data type: String\n\n</td></tr><tr><td>\n\nerror\n\n</td><td>\n\nIf an error occurred during processing, the details about the error.Data type: Object\n\n```\n\"error\": {\n  \"detail\": \"String\",\n  \"message\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nerror.detail\n\n</td><td>\n\nAdditional information about the error.Data type: String\n\n</td></tr><tr><td>\n\nerror.message\n\n</td><td>\n\nError message that was generated while trying to process the request.Data type: String\n\n</td></tr><tr><td>\n\nlast\\_conflict\\_detection\\_time\n\n</td><td>\n\nAmount of time since the last conflict detection was run. Conflict detection is performed whenever a changeset is committed.Data type: Number\n\nUnit: Milliseconds\n\n</td></tr><tr><td>\n\nlast\\_updated\n\n</td><td>\n\nDate and time when a change was made to the associated configuration data through this changeset.Format: YYYY-mm-DD hh:mm:ss\n\nData type: String\n\n</td></tr><tr><td>\n\nnumber\n\n</td><td>\n\nUnique changeset number.Data type: String\n\n</td></tr><tr><td>\n\npublish\\_option\n\n</td><td>\n\nPublish option for the associated configured snapshots.\n\nValid values:\n\n-   publish\\_none: Don't publish any snapshots.\n-   publish\\_valid: Publish only those snapshots that pass validation after the commit.\n\nFor additional information on publishing snapshots, see [Publish or unpublish a snapshot](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/it-service-management/cdm-snapshot-publish.md).\n\nData type: String\n\nDefault: publish\\_none\n\n</td></tr><tr><td>\n\nstate\n\n</td><td>\n\nCurrent state of the changeset.Possible values:\n\n-   Blocked\n-   Checking for conflict\n-   Commit failed\n-   Commit in progress\n-   Committed\n-   Open\n\nData type: String\n\n</td></tr><tr><td>\n\nsys\\_created\\_by\n\n</td><td id=\"sys_created_by-changeset-entry\">\n\nUser name of the user that created the changeset. For example, able.tuter.Data type: String\n\n</td></tr><tr><td>\n\nsys\\_created\\_on\n\n</td><td id=\"sys_created_on-changeset-entry\">\n\nDate and time when the changeset was created.Data type: String\n\nFormat: YYYY-mm-DD hh:mm:ss\n\n</td></tr><tr><td>\n\nsys\\_id\n\n</td><td id=\"sys_id-changeset-entry\">\n\nSys\\_id of the changeset.Data type: String\n\nTable: CDMChangeset \\[sn\\_cdm\\_changeset\\]\n\n</td></tr><tr><td>\n\nsys\\_updated\\_by\n\n</td><td id=\"sys_updated_by-changeset-entry\">\n\nUser name of the user that last updated the changeset. For example, able.tuter.Data type: String\n\n</td></tr><tr><td>\n\nsys\\_updated\\_on\n\n</td><td id=\"sys_updated_on-changeset-entry\">\n\nDate and time when the changeset was last updated.Data type: String\n\nFormat: YYYY-mm-DD hh:mm:ss\n\n</td></tr><tr><td>\n\ntitle\n\n</td><td>\n\nTitle of the changeset.Data type: String\n\n</td></tr></tbody>\n</table>### cURL request\n\nThis code example shows how to retrieve a specific changeset.\n\n```\ncurl \"http://instance.servicenow.com/api/sn_cdm/changesets?appName=testApp&changesetNumber=Chset-946&state=committed\" \\ \n--request GET \\ \n--header \"Accept:application/json\" \\ \n--user 'username':'password'\n```\n\nReturn results:\n\n```\n{ \n  \"result\": [ \n    { \n      \"description\": \"Auto generated for deletion of CDM Deployable Dep-12022-06-29 13:09:46\", \n      \"cdm_application\": { \n        \"value\": \"62b517a953b70110a1d3ddeeff7b128c\", \n        \"link\": \"http://instance.servicenow.com/api/now/table/sn_cdm_application/62b517a953b70110a1d3ddeeff7b128c\" \n      }, \n      \"sys_updated_on\": \"2022-06-29 13:09:47\", \n      \"title\": \"Auto generated for deletion of CDM Deployable Dep-12022-06-29 13:09:46\", \n      \"number\": \"Chset-946\", \n      \"sys_id\": \"955d6c0f53141110a1d3ddeeff7b1233\", \n      \"sys_updated_by\": \"admin\", \n      \"committed_at\": \"2022-06-29 13:09:46\", \n      \"sys_created_on\": \"2022-06-29 13:09:46\", \n      \"committed_by\": { \n        \"value\": \"6816f79cc0a8016401c5a33be04be441\", \n        \"link\": \"http://instance.servicenow.com/api/now/table/sys_user/6816f79cc0a8016401c5a33be04be441\" \n      }, \n      \"state\": \"committed\", \n      \"auto_validate\": true, \n      \"publish_option\": \"publish_none\", \n      \"last_conflict_detection_time\": \"1656508187450\", \n      \"sys_created_by\": \"admin\", \n      \"last_updated\": \"2022-06-29 13:09:46\" \n    } \n  ] \n} \n```\n\n## CdmChangesetsApi - GET /sn\\_cdm/changesets/activity\n\nRetrieves the node changes within a specified changeset.\n\n### URL format\n\nVersioned URL: `/api/sn_cdm/{api_version}/changesets/activity`\n\nDefault URL: `/api/sn_cdm/changesets/activity`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr></tbody>\n</table><table class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nchangesetNumber\n\n</td><td id=\"changesetNumber-changeset-entry\">\n\nRequired. Unique identifier of the associated changeset, such as \"Chset-10\".\n\nData type: String\n\nTable: CDM Changeset \\[sn\\_cdm\\_changeset\\]\n\n</td></tr><tr><td>\n\nreturnFields\n\n</td><td id=\"cdm_apps-returnFields-entry\">\n\nList of fields to return as part of the response. Pass the record column names such as sys\\_id, sys\\_updated\\_by, or state.Data type: Array\n\nDefault: All fields as determined by the endpoint\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Header|Description|\n|------|-----------|\n|Accept|Data format of the response body. Only supports **application/json**.|\n\n|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Successful. The request was successfully processed.|\n|400|Bad Request. A bad request type or malformed request was detected.|\n|500|Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.|\n\n### Response body parameters\n\n<table><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nchangeset\\_id\n\n</td><td>\n\nDetails of the requested changeset. Data type: Object\n\n ```\n\"changeset_id\": {\n  \"link\": \"String\",\n  \"value\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nchangeset\\_id.link\n\n</td><td>\n\nQuery to use to call the Table REST endpoint to retrieve the associated changeset.Data type: String\n\n</td></tr><tr><td>\n\nchangeset\\_id.value\n\n</td><td>\n\nSys\\_id of the associated changeset.Data type: String\n\nTable: CDM Changeset \\[sn\\_cdm\\_changeset\\]\n\n</td></tr><tr><td>\n\nconflict\n\n</td><td>\n\nFlag that indicates whether there is a conflict in the associated changeset.Valid values:\n\n-   true: Conflict detected.\n-   false: No conflict found.\n\nData type: Boolean\n\n</td></tr><tr><td>\n\ncreated\n\n</td><td>\n\nDate and time when the node was created.Format: YYYY-mm-DD hh:mm:ss\n\nData type: String\n\n</td></tr><tr><td>\n\ncreated\\_by\n\n</td><td>\n\nUser name of the user that create the node. For example, able.tuter.Data type: String\n\n</td></tr><tr><td>\n\nerror\n\n</td><td>\n\nIf an error occurred during processing, the details about the error.Data type: Object\n\n```\n\"error\": {\n  \"detail\": \"String\",\n  \"message\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nerror.detail\n\n</td><td>\n\nAdditional information about the error.Data type: String\n\n</td></tr><tr><td>\n\nerror.message\n\n</td><td>\n\nError message that was generated while trying to process the request.Data type: String\n\n</td></tr><tr><td>\n\nname\\_path\n\n</td><td>\n\nNode path name.Data type: String\n\n</td></tr><tr><td>\n\nnew\\_name\n\n</td><td>\n\nCurrent name of the node.Data type: String\n\n</td></tr><tr><td>\n\nnew\\_value\n\n</td><td>\n\nCurrent value of the node. For leaf nodes and array literals.Data type: String\n\n</td></tr><tr><td>\n\nold\\_name\n\n</td><td>\n\nPrevious name of the node.Data type: String\n\n</td></tr><tr><td>\n\nold\\_value\n\n</td><td>\n\nPrevious value of the node. For leaf nodes and array literals.Data type: String\n\n</td></tr><tr><td>\n\nupdated\n\n</td><td>\n\nDate and time when the node was last updated.Format: YYYY-mm-DD hh:mm:ss\n\nData type: String\n\n</td></tr><tr><td>\n\nupdated\\_by\n\n</td><td>\n\nUser name of the user that last updated the node. For example, able.tuter.Data type: String\n\n</td></tr><tr><td>\n\nsecure\n\n</td><td>\n\nFlag that indicates whether the associated leaf node was secured.Valid values:\n\n-   true: Node was secured.\n-   false: Node was not secured.\n\nData type: Boolean\n\n</td></tr><tr><td>\n\ntype\n\n</td><td>\n\nNode type.\n\nPossible values:\n\n-   sn\\_cdm\\_node\\_collection\n-   sn\\_cdm\\_node\\_component\n-   sn\\_cdm\\_node\\_folder\n-   sn\\_cdm\\_node\\_cdi\n-   sn\\_cdm\\_node\\_variable\n\nData type: String\n\n</td></tr></tbody>\n</table>### cURL request\n\nThis code example shows how to retrieve the node changes for a specific changeset.\n\n```\ncurl \"http://instance.servicenow.com/api/sn_cdm/changesets/activity?changesetNumber=Chset-783\" \\ \n--request GET \\ \n--header \"Accept:application/json\" \\ \n--user 'username':'password'\n```\n\nReturn results:\n\n```\n{ \n  \"result\": [ \n    { \n      \"sys_id\": \"ed5d6c0f53141110a1d3ddeeff7b1233\", \n      \"changeset_id\": \"955d6c0f53141110a1d3ddeeff7b1233\", \n      \"new_value\": null, \n      \"new_state\": \"Deleted\", \n      \"new_name\": \"Dep-1\", \n      \"new_type\": \"Deployable\", \n      \"new_encrypted\": false, \n      \"updated_on\": \"2022-06-29 13:09:46\", \n      \"updated_by\": \"admin\", \n      \"resolution_method\": \"\", \n      \"conflict\": null, \n      \"path\": \"deployables/Dep-1\", \n      \"created_by\": null, \n      \"created_on\": null, \n      \"old_value\": null, \n      \"old_state\": \"Superseded\", \n      \"old_name\": \"Dep-1\", \n      \"old_type\": \"Deployable\", \n      \"old_encrypted\": false \n    } \n] \n} \n```\n\n## CdmChangesetsApi - GET /sn\\_cdm/changesets/commit-status/\\{commit\\_id\\}\n\nReturns the current status of the specified changeset commit request.\n\n### URL format\n\nVersioned URL: `/api/sn_cdm/{api_version}/changesets/commit-status/{commit_id}`\n\nDefault URL: `/api/sn_cdm/changesets/commit-status/{commit_id}`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr><tr><td>\n\ncommit\\_id\n\n</td><td>\n\nSys\\_id for the commit request whose status to return. This value is returned by the [CdmChangesetsApi - POST /sn\\_cdm/changesets/\\{changeset\\_id\\}/commit](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-apis/changesets-api.md) endpoint.\n\nData type: String\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Header|Description|\n|------|-----------|\n|Accept|Data format of the response body. Only supports **application/json**.|\n\n|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Successful. The request was successfully processed.|\n|400|Bad Request. A bad request type or malformed request was detected.|\n|500|Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.|\n\n### Response body parameters\n\n<table><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr id=\"cdm_apps-request_id-row\"><td>\n\ncommit\\_id\n\n</td><td>\n\nCommit request record sys\\_id. Same as that passed into the endpoint.Data type: String\n\n</td></tr><tr><td>\n\nerrors\n\n</td><td>\n\nDescription of the error\\(s\\) encountered during upload.Data type: String\n\n</td></tr><tr><td>\n\noutput\n\n</td><td>\n\nDescription of the uploaded data or if an error occurred during the upload, an error message describing the error that was encountered.Data type: Object\n\n```\n\"output\": {\n  \"auto_validate\": \"String\",\n  \"cdm_application\": \"String\",\n  \"committed_at\": \"String\",\n  \"committed_by\": \"String\",\n  \"description\": \"String\",\n  \"last_conflict_detection_time\": \"String\",\n  \"number\": \"String\",\n  \"publish_option\": \"String\",\n  \"snapshot_description\": \"String\",\n  \"snapshot_name\": \"String\",\n  \"state\": \"String\",\n  \"sys_created_by\": \"String\",\n  \"sys_id\": \"String\",\n  \"title\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\noutput.auto\\_validate\n\n</td><td>\n\nIndicates whether to invoke validation after the commit.Data type: String\n\n</td></tr><tr><td>\n\noutput.cdm\\_application\n\n</td><td>\n\nName of application under which the upload was performed.Data type: String\n\n</td></tr><tr><td>\n\noutput.committed\\_at\n\n</td><td>\n\nDate and time that the uploaded content was committed.Data type: String\n\n</td></tr><tr><td>\n\noutput.committed\\_by\n\n</td><td>\n\nSys\\_id of the record of the entity that performed the commit.Data type: String\n\n</td></tr><tr><td>\n\noutput.description\n\n</td><td>\n\nNot currently used.Data type: String\n\n</td></tr><tr><td>\n\noutput.last\\_conflict\\_detection\\_time\n\n</td><td>\n\nDate and time conflict detection invocation.Data type: String\n\n</td></tr><tr><td>\n\noutput.number\n\n</td><td>\n\nUnique number of the changeset.Data type: String\n\n</td></tr><tr><td>\n\noutput.publish\\_option\n\n</td><td>\n\nPublish option for the associated configured snapshots.\n\nValid values:\n\n-   publish\\_none: Don't publish any snapshots.\n-   publish\\_valid: Publish only those snapshots that pass validation after the commit.\n\nFor additional information on publishing snapshots, see [Publish or unpublish a snapshot](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/it-service-management/cdm-snapshot-publish.md).\n\nData type: String\n\nDefault: publish\\_none\n\n</td></tr><tr><td>\n\noutput.snapshot\\_description\n\n</td><td>\n\nDescription of the associated snapshot.Data type: String\n\n</td></tr><tr><td>\n\noutput.snapshot\\_name\n\n</td><td>\n\nName of the associated snapshot.Data type: String\n\n</td></tr><tr><td>\n\noutput.state\n\n</td><td>\n\nState of the upload content.Possible values:\n\n-   committed\n-   completed\n-   error\n-   in\\_progress\n-   new\n-   ready\n\nData type: String\n\n</td></tr><tr><td>\n\noutput.sys\\_created\\_by\n\n</td><td>\n\nSys\\_id of the entity that created the record.Data type: String\n\n</td></tr><tr><td>\n\noutput.sys\\_id\n\n</td><td>\n\nSys\\_id of the record containing the changeset.Data type: String\n\n</td></tr><tr><td>\n\noutput.title\n\n</td><td>\n\nTitle of changeset created as part of the upload.Data type: String\n\n</td></tr><tr><td>\n\nprocessing\\_state\n\n</td><td>\n\nCurrent processing state of the commit request.Possible values:\n\n-   NOT\\_PROCREED\n-   PROCESSED\n\nData type: String\n\n</td></tr><tr id=\"cdm_apps-export_id-row\"><td>\n\nrequest\\_id\n\n</td><td>\n\nRequest ID. Same as that passed into the endpoint and **commit\\_id**.Data type: String\n\n</td></tr><tr id=\"cdm_apps-state-row\"><td>\n\nstate\n\n</td><td>\n\nCurrent state of the specified commit.Possible values:\n\n-   completed\n-   error\n-   in\\_progress\n-   new\n-   ready\n\nData type: String\n\nTable: Value from state column of the CDM Request Queue \\[sn\\_cdm\\_request\\_queue\\] table.\n\n</td></tr><tr><td>\n\ntype\n\n</td><td>\n\nType of request.Possible values:\n\n-   commit\n-   export\n-   upload\\_and\\_commit\n\nData type: String\n\n</td></tr></tbody>\n</table>### cURL request\n\nThe following example shows how to call this endpoint to obtain the status of the specified commit.\n\n```\ncurl \"http://instance.servicenow.com/api/sn_cdm/changesets/commit-status/bf506e69537c3010a1d3ddeeff7b12c0\"\\ \n--request GET \\ \n--header \"Accept:application/json\" \\ \n--user 'username':'password' \n```\n\nThe following shows examples of a success and error response.\n\n```\n\n// Successful response \n\n{ \n  \"result\": { \n    \"type\": \"commit\", \n    \"state\": \"completed\", \n    \"output\": { \n      \"sys_id\": \"4a4407e953124110da35ddeeff7b1235\", \n      \"number\": \"Chset-1207\", \n      \"title\": \"admin064407e953124110da35ddeeff7b1235\", \n      \"description\": \"A description of my changeset provided during creation\", \n      \"committed_at\": \"2022-03-17 22:19:33\", \n      \"committed_by\": \"6816f79cc0a8016401c5a33be04be441\", \n      \"sys_created_by\": \"admin\", \n      \"state\": \"committed\", \n      \"publish_option\": \"publish_none\", \n      \"auto_validate\": false, \n      \"snapshot_name\": null, \n      \"snapshot_description\": null, \n      \"cdm_application\": \"DemoApp\", \n      \"last_conflict_detection_time\": null \n    }, \n    \"processing_state\": \"PROCESSED\", \n    \"commit_id\": \"9cd583e953124110da35ddeeff7b128a\" \n  } \n} \n\n \n\n// Example of an error response \n\n{ \n  \"result\": { \n    \"state\": \"error\", \n    \"errors\": \"Invalid requestId '9cd583e953124110da35ddeeff7b128'\", \n    \"commit_id\": \"9cd583e953124110da35ddeeff7b128\" \n  } \n} \n\n\n```\n\n## CdmChangesetsApi - GET /sn\\_cdm/changesets/impacted-deployables\n\nReturns the list of deployables that are associated with a specified changeset.\n\nThe CDM Viewer role is required to access this endpoint.\n\n### URL format\n\nVersioned URL: `/api/sn_cdm/{api_version}/changesets/impacted-deployables`\n\nDefault URL: `/api/sn_cdm/changesets/impacted-deployables`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr></tbody>\n</table><table class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nchangesetNumber\n\n</td><td id=\"changesetNumber-changeset-entry\">\n\nRequired. Unique identifier of the associated changeset, such as \"Chset-10\".\n\nData type: String\n\nTable: CDM Changeset \\[sn\\_cdm\\_changeset\\]\n\n</td></tr><tr><td>\n\nreturnFields\n\n</td><td id=\"cdm_apps-returnFields-entry\">\n\nList of fields to return as part of the response. Pass the record column names such as sys\\_id, sys\\_updated\\_by, or state.Data type: Array\n\nDefault: All fields as determined by the endpoint\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Header|Description|\n|------|-----------|\n|Accept|Data format of the response body. Only supports **application/json**.|\n\n|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Successful. The request was successfully processed.|\n|400|Bad Request. A bad request type or malformed request was detected.|\n|500|Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.|\n\n### Response body parameters\n\n<table id=\"id_lcm_5dn_qtb\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\ncdi\\_count\n\n</td><td>\n\nNumber of configuration data items \\(CDIs\\) contained in the associated CDM application.Data type: Number \\(Integer\\)\n\n</td></tr><tr><td>\n\ncdi\\_usage\n\n</td><td>\n\nPercentage of the CDIs used by the deployable.Data type: Number \\(Integer\\)\n\n</td></tr><tr><td>\n\ncdm\\_app\n\n</td><td>\n\nCDM application object associated with the deployable.Data type: Object\n\n```\n\"cdm_app\": {\n  \"link\": \"String\",\n  \"value\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\ncdm\\_app.link\n\n</td><td id=\"cdm_app_link-app-entry\">\n\nCall to use to access the CDM application record using the REST Table API. Data type: String\n\n</td></tr><tr><td>\n\ncdm\\_app.value\n\n</td><td id=\"cdm_app_value-app-entry\">\n\nSys\\_id of the associated CDM application record.Data type: String\n\nTable: CDM Application \\[sn\\_cdm\\_application\\]\n\n</td></tr><tr><td>\n\ncdm\\_ci\n\n</td><td>\n\nApplication service object associated with the deployable.Data type: Object\n\n```\n\"cdm_ci\": {\n  \"link\": \"String\",\n  \"value\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\ncdm\\_ci.link\n\n</td><td>\n\nCall to use to access the application service record using the REST Table API.Data type: String\n\n</td></tr><tr><td>\n\ncdm\\_ci.value\n\n</td><td>\n\nSys\\_id of the associated application service record. Data type: String\n\nTable: Configuration Item \\[cmdb\\_ci\\]\n\n</td></tr><tr><td>\n\ndescription\n\n</td><td>\n\nDescription of the generated CDM deployable.Data type: String\n\n</td></tr><tr><td>\n\nenvironment\\_type\n\n</td><td>\n\nEnvironment type of the deployable.Possible values:\n\n-   Development\n-   Production\n-   Test\n\nData type: String\n\n</td></tr><tr><td>\n\nerror\n\n</td><td id=\"cdm_apps-error-entry\">\n\nOnly returned if an error occurred during processing.Data type: Object\n\n```\n\"error\": {\n  \"detail\": \"String\",\n  \"message\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nerror.detail\n\n</td><td>\n\nAdditional information about the error.Data type: String\n\n</td></tr><tr><td>\n\nerror.message\n\n</td><td>\n\nError message that was generated while trying to process the request.Data type: String\n\n</td></tr><tr><td>\n\nname\n\n</td><td>\n\nName of the CDM deployable.Data type: String\n\n</td></tr><tr><td>\n\nnode\n\n</td><td>\n\nDetails about the deployable node.Data type: Object\n\n```\n\"node\": {\n  \"link\": \"String\",\n  \"value\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nnode.link\n\n</td><td>\n\nCall to use to access the deployable node record using the REST Table API. Data type: String\n\n</td></tr><tr><td>\n\nnode.value\n\n</td><td>\n\nSys\\_id of the deployable node record.Data type: String\n\nTable: CDM Deployable \\[sn\\_cdm\\_deployable\\]\n\n</td></tr><tr><td>\n\nsnapshot\\_version\\_counter\n\n</td><td>\n\nNumber of snapshots created for the deployable.Data type: Number \\(Integer\\)\n\n</td></tr><tr><td>\n\nstate\n\n</td><td>\n\nCurrent state of the deployable.Possible values:\n\n-   active\n-   deleted\n\nData type: String\n\n</td></tr><tr id=\"cdm_dep-sys_created_by-row\"><td>\n\nsys\\_created\\_by\n\n</td><td>\n\nUser name of the user that created the CDM deployable. For example, able.tuter.Data type: String\n\n</td></tr><tr id=\"cdm_deps-sys_created_on-row\"><td>\n\nsys\\_created\\_on\n\n</td><td>\n\nDate and time when the CDM deployable was created.Data type: String\n\nFormat: YYYY-mm-DD hh:mm:ss\n\n</td></tr><tr><td>\n\nsys\\_id\n\n</td><td>\n\nSys\\_id of the created deployable.Data type: String\n\nTable: CDM Deployable \\[sn\\_cdm\\_deployable\\]\n\n</td></tr><tr id=\"cdm_dep-sys_updated_by-row\"><td>\n\nsys\\_updated\\_by\n\n</td><td>\n\nUser name of the user that last updated the CDM deployable. For example, able.tuter.Data type: String\n\n</td></tr><tr id=\"cdm_dep-sys_updated_on-row\"><td>\n\nsys\\_updated\\_on\n\n</td><td>\n\nDate and time when the CDM deployable was last updated.Data type: String\n\nFormat: YYYY-mm-DD hh:mm:ss\n\n</td></tr></tbody>\n</table>### cURL request\n\nThe following code example shows how to retrieve the impacted deployables for a specified changeset.\n\n```\ncurl \"http://instance.servicenow.com/api/sn_cdm/changesets/impacted-deployables?changesetNumber=Chset-783\" \\ \n--request GET \\ \n--header \"Accept:application/json\" \\ \n--user 'username':'password'\n```\n\nReturn results:\n\n```\n{ \n  \"result\": [ \n    { \n      \"cmdb_ci\": { \n        \"value\": \"75c5d7a953b70110a1d3ddeeff7b12a2\", \n        \"link\": \"http://instance.servicenow.com/api/now/table/cmdb_ci_service_auto/75c5d7a953b70110a1d3ddeeff7b12a2\" \n      }, \n      \"cdi_count\": \"2\", \n      \"snapshot_version_counter\": \"3\", \n      \"description\": null, \n      \"sys_updated_on\": \"2022-06-29 16:19:05\", \n      \"environment_type\": \"Development\", \n      \"node\": { \n        \"value\": \"a1c517a953b70110a1d3ddeeff7b129b\", \n        \"link\": \"http://instance.servicenow.com/api/now/table/sn_cdm_node/a1c517a953b70110a1d3ddeeff7b129b\" \n      }, \n      \"sys_id\": \"6dc517a953b70110a1d3ddeeff7b129b\", \n      \"sys_updated_by\": \"admin\", \n      \"cdm_app\": { \n        \"value\": \"62b517a953b70110a1d3ddeeff7b128c\", \n        \"link\": \"http://instance.servicenow.com/api/now/table/sn_cdm_application/62b517a953b70110a1d3ddeeff7b128c\" \n      }, \n      \"sys_created_on\": \"2022-05-31 13:03:23\", \n      \"cdi_usage\": \"0.02\", \n      \"name\": \"Development_1\", \n      \"state\": \"active\", \n      \"sys_created_by\": \"admin\" \n    } \n  ] \n}\n```\n\n## CdmChangesetsApi - GET /sn\\_cdm/changesets/impacted-shared-components\n\nReturns a list of shared components that are associated with a specified changeset.\n\nThe CDM Viewer role is required to access this endpoint.\n\n### URL format\n\nVersioned URL: `/api/sn_cdm/{api_version}/changesets/impacted-shared-components`\n\nDefault URL: `/api/sn_cdm/changesets/impacted-shared-components`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr></tbody>\n</table><table class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nchangesetNumber\n\n</td><td id=\"changesetNumber-changeset-entry\">\n\nRequired. Unique identifier of the associated changeset, such as \"Chset-10\".\n\nData type: String\n\nTable: CDM Changeset \\[sn\\_cdm\\_changeset\\]\n\n</td></tr><tr><td>\n\nreturnFields\n\n</td><td id=\"cdm_apps-returnFields-entry\">\n\nList of fields to return as part of the response. Pass the record column names such as sys\\_id, sys\\_updated\\_by, or state.Data type: Array\n\nDefault: All fields as determined by the endpoint\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Header|Description|\n|------|-----------|\n|Accept|Data format of the response body. Only supports **application/json**.|\n\n|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Successful. The request was successfully processed.|\n|400|Bad Request. The passed changeset does not exist.|\n|500|Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.|\n\n### Response body parameters\n\n<table><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\ncdm\\_shared\\_\\_library\n\n</td><td>\n\nSys\\_id of the shared library under which the component resides.Data type: String\n\n</td></tr><tr><td>\n\ndescription\n\n</td><td>\n\nDescription of the CDM shared component.Data type: String\n\n</td></tr><tr><td>\n\nerror\n\n</td><td id=\"cdm_apps-error-entry\">\n\nOnly returned if an error occurred during processing.Data type: Object\n\n```\n\"error\": {\n  \"detail\": \"String\",\n  \"message\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nerror.detail\n\n</td><td id=\"cdm_apps-error_detail-entry\">\n\nDetails about the error that occurred.Data type: String\n\n</td></tr><tr><td>\n\nerror.message\n\n</td><td id=\"cdm_apps-error_message-entry\">\n\nMessage that provides an overview of the error.Data type: String\n\n</td></tr><tr><td>\n\nname\n\n</td><td>\n\nName of the CDM shared component.Data type: String\n\n</td></tr><tr><td>\n\nnode\n\n</td><td>\n\nSys\\_id of the shared component node.Data type: String\n\nTable: CDM Node \\[sn\\_cdm\\_node\\]\n\n</td></tr><tr><td>\n\nnode\\_main\n\n</td><td>\n\nSys\\_id of the main\\_id of the shared component node record.Data type: String\n\nTable: CDM Node Main \\[sn\\_cdm\\_node\\_main\\]\n\n</td></tr><tr><td>\n\nstate\n\n</td><td>\n\nCurrent state of the shared component.Possible values:\n\n-   active\n-   deleted\n\nData type: String\n\n</td></tr><tr id=\"cdm_dep-sys_created_by-row\"><td>\n\nsys\\_created\\_by\n\n</td><td>\n\nUser name of the user that create the CDM shared component. For example, able.tuter.Data type: String\n\n</td></tr><tr id=\"cdm_deps-sys_created_on-row\"><td>\n\nsys\\_created\\_on\n\n</td><td>\n\nDate and time when the CDM shared component was created.Format: YYYY-mm-DD hh:mm:ss\n\nData type: String\n\n</td></tr><tr><td>\n\nsys\\_id\n\n</td><td>\n\nSys\\_id of the shared component.Data type: String\n\nTable: CDM Shared Component \\[sn\\_cdm\\_shared\\_component\\]\n\n</td></tr><tr id=\"cdm_dep-sys_updated_by-row\"><td>\n\nsys\\_updated\\_by\n\n</td><td>\n\nUser name of the user that last updated the CDM shared component. For example, able.tuter.Data type: String\n\n</td></tr><tr id=\"cdm_dep-sys_updated_on-row\"><td>\n\nsys\\_updated\\_on\n\n</td><td>\n\nDate and time when the CDM shared component was last updated.Format: YYYY-mm-DD hh:mm:ss\n\n Data type: String\n\n</td></tr><tr><td>\n\nversion\\_counter\n\n</td><td>\n\nNumber of versions created for the shared component.Data type: Integer\n\n</td></tr></tbody>\n</table>### cURL request\n\nThe following code example shows how to retrieve the impacted shared components for changeset = \"Chset-20\".\n\n```\ncurl \"https://instance.servicenow.com/sn_cdm/changesets/impacted-shared-components?changesetNumber=Chset-20\" \\ \n--request GET \\ \n--header \"Accept:application/json\" \\ \n--user 'username':'password' \n\n```\n\nResponse:\n\n```\n{\n  \"result\": [\n    {\n      \"version_counter\": \"1\",\n      \"description\": null,\n      \"cdm_shared_library\": \"acb905e097b3991052687b890353afcd\",\n      \"sys_updated_on\": \"2022-12-12 20:28:49\",\n      \"node\": \"3cb945e097b3991052687b890353af0d\",\n      \"sys_id\": \"34b945e097b3991052687b890353af20\",\n      \"sys_updated_by\": \"john.jones\",\n      \"node_main\": \"74b945e097b3991052687b890353af0d\",\n      \"sys_created_on\": \"2022-12-12 20:28:39\",\n      \"name\": \"logonService-V2.1\",\n      \"state\": \"active\",\n      \"sys_created_by\": \"john.jones\"\n    },\n    {\n      \"version_counter\": \"1\",\n      \"description\": null,\n      \"cdm_shared_library\": \"acb905e097b3991052687b890353afcd\",\n      \"sys_updated_on\": \"2022-12-12 20:28:49\",\n      \"node\": \"b0b945e097b3991052687b890353af11\",\n      \"sys_id\": \"30b945e097b3991052687b890353af21\",\n      \"sys_updated_by\": \"john.jones\",\n      \"node_main\": \"f8b945e097b3991052687b890353af10\",\n      \"sys_created_on\": \"2022-12-12 20:28:39\",\n      \"name\": \"logonService-V2.2\",\n      \"state\": \"active\",\n      \"sys_created_by\": \"john.jones\"\n    },\n    {\n      \"version_counter\": \"1\",\n      \"description\": null,\n      \"cdm_shared_library\": \"acb905e097b3991052687b890353afcd\",\n      \"sys_updated_on\": \"2022-12-12 20:28:49\",\n      \"node\": \"6cb905e097b3991052687b890353afd3\",\n      \"sys_id\": \"b4b945e097b3991052687b890353af21\",\n      \"sys_updated_by\": \"john.jones\",\n      \"node_main\": \"a4b905e097b3991052687b890353afd3\",\n      \"sys_created_on\": \"2022-12-12 20:28:39\",\n      \"name\": \"paymentService-V1.0\",\n      \"state\": \"active\",\n      \"sys_created_by\": \"john.jones\"\n    },\n    {\n      \"version_counter\": \"1\",\n      \"description\": null,\n      \"cdm_shared_library\": \"acb905e097b3991052687b890353afcd\",\n      \"sys_updated_on\": \"2022-12-12 20:28:49\",\n      \"node\": \"e0b905e097b3991052687b890353aff1\",\n      \"sys_id\": \"3cb945e097b3991052687b890353af21\",\n      \"sys_updated_by\": \"john.jones\",\n      \"node_main\": \"2cb905e097b3991052687b890353aff0\",\n      \"sys_created_on\": \"2022-12-12 20:28:39\",\n      \"name\": \"paymentService-V1.1\",\n      \"state\": \"active\",\n      \"sys_created_by\": \"john.jones\"\n    }\n  ]\n}\n```\n\n## CdmChangesetsApi - GET /sn\\_cdm/changesets/\\{changeset\\_id\\}/impacted-deployables\n\nReturns the list of deployables that are associated with a specified changeset.\n\n### URL format\n\nVersioned URL: `/api/sn_cdm/{api_version}/changesets/{changeset_id}/impacted-deployables`\n\nDefault URL: `/api/sn_cdm/changesets/{changeset_id}/impacted-deployables`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr><tr><td>\n\nchangeset\\_id\n\n</td><td>\n\nSys\\_id of the changeset record to process.Data type: String\n\nTable:CDM Changeset \\[sn\\_cdm\\_changeset\\]\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Header|Description|\n|------|-----------|\n|Accept|Data format of the response body. Only supports **application/json**.|\n\n|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Successful. The request was successfully processed.|\n|400|Bad Request. A bad request type or malformed request was detected.|\n|500|Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.|\n\n### Response body parameters\n\n<table><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nchangeset\\_id\n\n</td><td>\n\nSys\\_id of the last changeset associated with the deployable node.Data type: String\n\n</td></tr><tr><td>\n\nconflict\n\n</td><td>\n\nFlag that indicates whether the associated deployable is in conflict.Possible values:\n\n-   0: Not in conflict.\n-   1: Conflicted - refer to the **conflict\\_type** return result for additional information.\n\nData type: Number\n\n</td></tr><tr><td>\n\nconflict\\_type\n\n</td><td>\n\nType of deployable conflict.Possible values:\n\n-   corrupted\\_node\n-   deleted\\_node\n-   duplicated\\_node\n-   incomplete\\_deleted\\_parent\n-   incomplete\\_deleted\\_ref\n-   incomplete\\_renamed\\_ref\n-   invalid\\_include\n-   orphaned\\_descendant\n-   related\\_conflict\n-   unlinked\\_include\n-   unrenamed\\_include\n-   updated\\_node\n\nData type: String\n\n</td></tr><tr><td>\n\ndescription\n\n</td><td>\n\nDescription of the deployable node.Data type: String\n\n</td></tr><tr><td>\n\neffective\\_from\n\n</td><td>\n\nTimestamp when the node is valid. This value is `null` until you commit a changeset in which the node was created.Data type: Number\n\n</td></tr><tr><td>\n\neffective\\_to\n\n</td><td>\n\nTimestamp when the node is no longer valid. If this value is `null`, the node stays in affect until it is replaced with a new version.Data type: Number\n\n</td></tr><tr><td>\n\nerror\n\n</td><td>\n\nIf an error occurred during processing, the details about the error.Data type: Object\n\n```\n\"error\": {\n  \"detail\": \"String\",\n  \"message\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nerror.detail\n\n</td><td>\n\nAdditional information about the error.Data type: String\n\n</td></tr><tr><td>\n\nerror.message\n\n</td><td>\n\nError message that was generated while trying to process the request.Data type: String\n\n</td></tr><tr><td>\n\nlevel\n\n</td><td>\n\nDepth of the node starting from the application level, which is 0.Data type: Number\n\n</td></tr><tr><td>\n\nlinked\\_to\n\n</td><td>\n\nID of the reference node within a collection and component.For example, the following node snippet shows a link between the collection collA and the component compA. For this example, the **linkedTo** value is `1`:\n\n```\n{ \ncomponents : {compA:{} //MainId: 1}, \n\nCollections : { collA : {  \n   compA :{} //Include, linkedTo: 1 \n    } \n  } \n} \n```\n\nData type: String\n\n</td></tr><tr><td>\n\nmain\\_id\n\n</td><td>\n\nUnique identifier of the deployable node. This value is generated when the node is created and used to identify the deployable node.Data type: Number\n\n</td></tr><tr><td>\n\nmain\\_id\\_encoded\n\n</td><td>\n\nEncoded value of the **mainId** return results, using Radix 57 string representation.Data type: String\n\n</td></tr><tr><td>\n\nname\n\n</td><td>\n\nName of the deployable.Data type: String\n\n</td></tr><tr><td>\n\nnode\\_classifier\n\n</td><td>\n\nNode classification, such as Development, Production, or Test. In the format:\n\n-   /application/deployables/env:Development\n-   /application/deployables/env:Production\n-   /application/deployables/env:Test\n\nData type: String\n\n</td></tr><tr><td>\n\nposition\n\n</td><td>\n\nDeployable node position. Only applicable to arrays.For example, for the array:\n\n```\nnode1:{\n  arrayNode: [{}, \"literal1\", \"literal2\", []] }\n```\n\n\\{\\} is position 1000,\n\n\"literal1\" is position 2000,\n\n\"literal2\" is position 3000,\n\n\\[\\] is position 4000\n\nData type: Number\n\n</td></tr><tr><td>\n\nprevious\\_version\n\n</td><td>\n\nSys\\_id of the previous version of the associated deployable node.Data type: String\n\n</td></tr><tr><td>\n\nrestricted\\_to\n\n</td><td>\n\nList of sys\\_ids of the users that are allowed to access the associated deployable node. This value is `null` if all groups can access the deployable.Data type: String\n\nTable: CDM Restricted Groups \\[sn\\_cdm\\_restricted\\_groups\\]\n\n</td></tr><tr><td>\n\nsecure\\_value\n\n</td><td>\n\nSecure value of the CDI or variable. Only returned for leaf nodes and array literals. This is the same as the **value** return result, but is encrypted.Data type: String\n\n</td></tr><tr><td>\n\nstatus\n\n</td><td>\n\nStatus of deployable node or the status of a failed request.Possible values:\n\n-   deleted\n-   failure \\(passed if endpoint call fails.\\)\n-   new\n-   superseded\n-   updated\n-   valid\n\nData type: String\n\n</td></tr><tr><td>\n\nsystem\\_folder\n\n</td><td>\n\nFlag that indicates whether the associated folder is a system folder.Possible values:\n\n-   0: Not a system folder.\n-   1: System folder.\n\nData type: Number\n\n</td></tr><tr><td>\n\nsys\\_id\n\n</td><td>\n\nSys\\_id of the impacted deployable.Data type: String\n\n</td></tr><tr><td>\n\ntype\n\n</td><td>\n\nNode type, such as sn\\_cdm\\_node\\_deployable. This value enables you to determine whether the node is a component, config data item \\(CDI\\), or deployable. This value is generated when the node is created.Data type: String\n\n</td></tr><tr><td>\n\nvalue\n\n</td><td>\n\nValue of the CDI or variable. Only returned for leaf nodes and array literals. If this information is encrypted, it is returned in the **secure\\_value** return result.For example, if this node is the CDI `nodeA:{cdi1: 1}`, the **value** return result is `1`. If it is an array node such as `node1: {arrayNode: [{}, \"literal1\", \"literal2\", []]}`, the **value** return result is `literal1`.\n\nData type: String\n\n</td></tr></tbody>\n</table>### cURL request\n\nThe following example shows how to request the deployables that are associated with the changeset whose sys\\_id is bf506e69537c3010a1d3ddeeff7b12c0.\n\n```\ncurl \"http://instance.servicenow.com/api/sn_cdm/changesets/bf506e69537c3010a1d3ddeeff7b12c0/impacted-deployables\"\\ \n--request GET \\ \n--header \"Accept:application/json\" \\ \n--user 'username':'password' \n```\n\nThe following shows both a successful and an error response for this endpoint.\n\n```\n// Successful response\n{\n  \"result\": [\n    {\n      \"sys_id\": \"833527a953924110da35ddeeff7b12c1\",\n      \"type\": \"sn_cdm_node_deployable\",\n      \"main_id\": \"150\",\n      \"main_id_encoded\": \"&M\",\n      \"node_path\": \"!&@!&D!&M\",\n      \"level\": 2,\n      \"status\": \"valid\",\n      \"node_classifier\": \"/application/deployables/env:Development\",\n      \"position\": null,\n      \"restricted_to\": null,\n      \"changeset_id\": \"cb3527a953924110da35ddeeff7b12c0\",\n      \"previous_version\": \"e8946f6953924110da35ddeeff7b1264\",\n      \"effective_from\": \"1647563806950\",\n      \"effective_to\": null,\n      \"name\": \"Development_1\",\n      \"description\": \"dev deployable decription\",\n      \"value\": null,\n      \"secure_value\": null,\n      \"system_folder\": \"0\",\n      \"linked_to\": null,\n      \"conflict\": \"0\",\n      \"conflict_type\": null\n    },\n    {\n      \"sys_id\": \"a245e7a953924110da35ddeeff7b1223\",\n      \"type\": \"sn_cdm_node_deployable\",\n      \"main_id\": \"153\",\n      \"main_id_encoded\": \"&P\",\n      \"node_path\": \"!&@!&D!&P\",\n      \"level\": 2,\n      \"status\": \"valid\",\n      \"node_classifier\": \"/application/deployables/env:Test\",\n      \"position\": null,\n      \"restricted_to\": null,\n      \"changeset_id\": \"ea45e7a953924110da35ddeeff7b1222\",\n      \"previous_version\": \"9505ef6953924110da35ddeeff7b121a\",\n      \"effective_from\": \"1647563821422\",\n      \"effective_to\": null,\n      \"name\": \"Test_1\",\n      \"description\": \"test deployable decription\",\n      \"value\": null,\n      \"secure_value\": null,\n      \"system_folder\": \"0\",\n      \"linked_to\": null,\n      \"conflict\": \"0\",\n      \"conflict_type\": null\n    }\n  ]\n} \n\n// Example of an error response\n{\n  \"error\": {\n    \"message\": \"Error: Unexpected error occurred in create request.Error:Application not found\",\n    \"detail\": \"\"\n  },\n  \"status\": \"failure\"\n}\n```\n\n## CdmChangesetsApi - POST /sn\\_cdm/changesets/\\{changeset\\_id\\}/commit\n\nCommits the specified changeset. Once committed, the changeset is persisted into the CDM tables within the associated instance.\n\nThe system updates the application to persist the changes to the configuration data within the changeset. The changeset state changes to **Committed**. The system then generates a snapshot of each deployable that is affected by the changeset.\n\nThis endpoint returns the ID of the commit request. Use this ID to call the [CdmChangesetsApi - GET /sn\\_cdm/changesets/commit-status/\\{commit\\_id\\}](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-apis/changesets-api.md) endpoint to obtain the current status of the changeset commit.\n\n### URL format\n\nVersioned URL: `/api/sn_cdm/{api_version}/changesets/{changeset_id}/commit`\n\nDefault URL: `/api/sn_cdm/changesets/{changeset_id}/commit`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr><tr><td>\n\nchangeset\\_id\n\n</td><td>\n\nSys\\_id of the changeset record to process.Data type: String\n\nTable:CDM Changeset \\[sn\\_cdm\\_changeset\\]\n\n</td></tr></tbody>\n</table><table class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nautoValidate\n\n</td><td>\n\nFlag that indicates whether the snapshots created upon commit are validated, meaning any associated policies are run against the snapshot.Valid values:\n\n-   true: Validate the snapshots.\n-   false: Do not validate the snapshots.\n\nDefault: false\n\n</td></tr><tr><td>\n\npublishOption\n\n</td><td>\n\nPublish option for the associated configuration snapshots. Valid values:\n\n-   publish\\_none: Do not publish any snapshots.\n-   publish\\_valid: Publish only those snapshots that pass validation after the commit.\n\n**Note:** This option is only available if the value for the **autoCommit** parameter is true.\n\nFor additional information on publishing snapshots, see [Publish or unpublish a snapshot](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/it-service-management/cdm-snapshot-publish.md).\n\nData type: String\n\nDefault: publish\\_none\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Header|Description|\n|------|-----------|\n|Accept|Data format of the response body. Only supports **application/json**.|\n|Content-Type|Data format of the request body. Only supports **application/json**.|\n\n|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n<table><thead><tr><th>\n\nStatus code\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\n200\n\n</td><td id=\"entry-200-status-code\">\n\nSuccessful. The request was successfully processed.\n\n</td></tr><tr><td>\n\n400\n\n</td><td>\n\nBad Request. Error: &lt;Error message&gt;Validate that the **changeset\\_id** parameter that you passed in was correct.\n\nEnsure that you have the required roles to access this endpoint.\n\n</td></tr><tr><td>\n\n500\n\n</td><td>\n\nInternal Server Error Error: Invalid boolean value.If you passed in the **autoValidate** parameter, verify that it is a boolean value.\n\n</td></tr></tbody>\n</table>### Response body parameters\n\n<table id=\"id_bgt_byy_ztb\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\ncommit\\_id\n\n</td><td>\n\nSys\\_id of the commit request. Use this ID when calling the [CdmChangesetsApi - GET /sn\\_cdm/changesets/commit-status/\\{commit\\_id\\}](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-apis/changesets-api.md) endpoint to check the status of the commit request.\n\nData type: String\n\n</td></tr><tr><td>\n\nerror\n\n</td><td>\n\nIf an error occurred during processing, the details about the error.Data type: Object\n\n```\n\"error\": {\n  \"detail\": \"String\",\n  \"message\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nerror.detail\n\n</td><td>\n\nAdditional information about the error.Data type: String\n\n</td></tr><tr><td>\n\nerror.message\n\n</td><td>\n\nError message that was generated while trying to process the request.Data type: String\n\n</td></tr><tr><td>\n\nstatus\n\n</td><td>\n\nStatus of the commit. Only returned when an error occurs.Possible values: failure\n\nData type: String\n\n</td></tr></tbody>\n</table>### cURL request\n\nThe following example shows how to call this endpoint to commit a changeset record.\n\n```\ncurl \"http://instance.servicenow.com/api/sn_cdm/changesets/29e24001533030104bacddeeff7b120c/commit?publishOption=publish_valid\"\\ \n--request POST \\ \n--header \"Accept:application/json\" \\ \n--header \"Content-Type:application/json\" \\\n--user 'username':'password' \n```\n\nThe following shows the response for a successful changeset commit request.\n\n```\n// Successful response\n{ \n  \"result\": { \n    \"commit_id\": \"64b5f79f5379301096edddeeff7b12eb\" \n  } \n}\n\n// Example of an error response\n{\n  \"error\": {\n    \"message\": \"Error: Unexpected error occurred in commit request.Error:Failed to insert request in queue\",\n    \"detail\": \"\"\n  },\n  \"status\": \"failure\"\n}\n```\n\n## CdmChangesetsApi - POST /sn\\_cdm/changesets/create\n\nCreates a new changeset in the open state for a specified CDM application or shared library.\n\nThe CDM Editor role is required to access this endpoint.\n\n### URL format\n\nVersioned URL: `/api/sn_cdm/{api_version}/changesets/create/`\n\nDefault URL: `/api/sn_cdm/changesets/create/`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr></tbody>\n</table><table class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nappName\n\n</td><td id=\"appName-changesets-entry\">\n\nRequired. Name of the CDM application or shared library to associate with this changeset. This must be an active application or shared library.Data type: String\n\n</td></tr><tr><td>\n\ndescription\n\n</td><td>\n\nChangeset description. Enter something that will allow others to understand the purpose of the changeset.Data type: String\n\n Default: None\n\n</td></tr><tr><td>\n\nreturnFields\n\n</td><td>\n\nComma separated list of fields in the CDM Changeset \\[sn\\_cdm\\_changeset\\] table to return as part of the response.Data type: String\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Header|Description|\n|------|-----------|\n|Accept|Data format of the response body. Only supports **application/json**.|\n|Content-Type|Data format of the request body. Only supports **application/json**.|\n\n|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n<table><thead><tr><th>\n\nStatus code\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\n200\n\n</td><td id=\"entry-200-status-code\">\n\nSuccessful. The request was successfully processed.\n\n</td></tr><tr><td>\n\n400\n\n</td><td>\n\nBad Request. Error: &lt;Error message&gt;Ensure that the specified CDM application or shared library exists and in the active state.\n\n</td></tr><tr><td>\n\n500\n\n</td><td id=\"entry-500-status-code\">\n\nInternal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.\n\n</td></tr></tbody>\n</table>### Response body parameters\n\n<table><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nauto\\_validate\n\n</td><td>\n\nFlag that indicates whether auto validation was performed.\n\n Possible values:\n\n-   true: Auto validation was performed.\n-   false: Auto validation was not preformed.\n\n Data type: Boolean\n\n</td></tr><tr><td>\n\ncdm\\_application\n\n</td><td>\n\nDetails about the CDM application associated with the changeset.Data type: Object\n\n ```\n\"cdm_application\": { \n  \"link\": \"String\",\n  \"value\": \"String\"\n}\n```\n\nFor example: `{\"value\": \"<sysId>\", \"link\": \"http://localhost:8081/api/now/table/*’}\"`\n\n</td></tr><tr><td>\n\ncdm\\_application.link\n\n</td><td>\n\nURL of the associated CDM application.Data type: String\n\n</td></tr><tr><td>\n\ncdm\\_application.value\n\n</td><td>\n\nSys\\_id of the associated CDM application.Data type: String\n\n</td></tr><tr><td>\n\ncommitted\\_at\n\n</td><td>\n\nDate and time that the changeset was committed to the associated repository.Data type: String\n\n</td></tr><tr><td>\n\ncommitted\\_by\n\n</td><td>\n\nSys\\_id of the entity that created the changeset.Data type: String\n\n</td></tr><tr><td>\n\ndescription\n\n</td><td>\n\nDescription of the changeset as passed when the endpoint was called.Data type: String\n\n</td></tr><tr><td>\n\nerror\n\n</td><td>\n\nIf an error occurred during processing, the details about the error.Data type: Object\n\n```\n\"error\": {\n  \"detail\": \"String\",\n  \"message\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nerror.detail\n\n</td><td>\n\nAdditional information about the error.Data type: String\n\n</td></tr><tr><td>\n\nerror.message\n\n</td><td>\n\nError message that was generated while trying to process the request.Data type: String\n\n</td></tr><tr><td>\n\nlast\\_conflict\\_detection\\_time\n\n</td><td>\n\nLast time conflict detection ran.Data type: Number\n\n Unit: Milliseconds\n\n</td></tr><tr><td>\n\nnumber\n\n</td><td>\n\nUnique identifier for the new changeset.Data type: String\n\n</td></tr><tr><td>\n\npublish\\_option\n\n</td><td>\n\nPublish option for the associated configured snapshots.\n\nValid values:\n\n-   publish\\_none: Don't publish any snapshots.\n-   publish\\_valid: Publish only those snapshots that pass validation after the commit.\n\nFor additional information on publishing snapshots, see [Publish or unpublish a snapshot](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/it-service-management/cdm-snapshot-publish.md).\n\nData type: String\n\nDefault: publish\\_none\n\n</td></tr><tr><td>\n\nsnapshot\\_description\n\n</td><td>\n\nDescription of the snapshot associated with the changeset.Data type: String\n\n</td></tr><tr><td>\n\nstate\n\n</td><td>\n\nState of the changeset creation.Possible values:\n\n-   Blocked\n-   Checking for conflict\n-   Commit failed\n-   Commit in progress\n-   Committed\n-   Open\n\n Data type: String\n\n</td></tr><tr><td>\n\nstatus\n\n</td><td>\n\nStatus of the changeset creation. Only returned when an error occurs.Possible values: failure\n\n Data type: String\n\n</td></tr><tr><td>\n\nsys\\_created\\_by\n\n</td><td>\n\nSys\\_id of the entity that created the changeset record.Data type: String\n\n</td></tr><tr><td>\n\nsys\\_id\n\n</td><td>\n\nSys\\_id of the new changeset.Data type: String\n\n</td></tr><tr><td>\n\ntitle\n\n</td><td>\n\nTitle of the changeset associated with the application. Typically auto-generated by the system.Data type: String\n\n</td></tr></tbody>\n</table>### cURL request\n\nThe following example shows how to create a changeset associated with the App Service1 CDM application.\n\n```\ncurl \"http://instance.servicenow.com/api/sn_cdm/changesets/create?appName=App%20Service1&description=Sample%20Description \\ \n--request POST \\ \n--header \"Accept:application/json\" \\ \n--header \"Content-Type:application/json\" \\\n--user 'username':'password' \n```\n\nThe following shows the response for a successful creation of the changeset.\n\n```\n// Example of a successful response\n{   \n\"result\": { \n    \"sys_id\": \"42748779c370301054c1582e1340ddcd\",\n    \"number\": \"Chset-8\",\n    \"title\": \"admin2021-06-18 10:06:46\",\n    \"description\": null,\n    \"committed_at\": \"\",\n    \"committed_by\": null,\n    \"sys_created_by\": \"admin\",\n    \"state\": \"open\",\n    \"publish_option\": \"publish_none\",\n    \"auto_validate\": false,\n    \"snapshot_name\": null,\n    \"snapshot_description\": null,\n    \"cdm_application\": \"App%20Service1\" \n  } \n}\n\n// Example of an error response\n{\n  \"error\": {\n    \"message\": \"Error: Unexpected error occurred in create request.Error:Application not found\",\n    \"detail\": \"\"\n  },\n  \"status\": \"failure\"\n}\n```\n\n### cURL request\n\nThe following example shows how to create a changeset for the shared library \"javalib\".\n\n```\ncurl \"http://instance.servicenow.com/api/sn_cdm/changesets/create?sharedLibraryName=javalib&description=description of changeset\" \\ \n--request POST \\ \n--header \"Accept:application/json\" \\ \n--user 'username':'password'  \n```\n\nResponse:\n\n```\n\n```\n\n## CdmChangesetsApi - PUT /sn\\_cdm/changesets/commit\n\nUpdates and commits a specified changeset.\n\nThe system updates the application to persist the changes to the configuration data within the changeset. The changeset state changes to **Committed**. The system then generates a snapshot of each deployable that is affected by the changeset.\n\nThis endpoint returns the ID of the commit request. Use this ID to call the [CdmChangesetsApi - GET /sn\\_cdm/changesets/commit-status/\\{commit\\_id\\}](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-apis/changesets-api.md) endpoint to obtain the current status of the changeset commit.\n\n### URL format\n\nVersioned URL: `/api/sn_cdm/{api_version}/changesets/{changeset_id}/commit`\n\nDefault URL: `/api/sn_cdm/changesets/{changeset_id}/commit`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr></tbody>\n</table><table class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nautoValidate\n\n</td><td id=\"autoValidate-changeset-entry\">\n\nFlag that indicates whether the snapshots created during the commit are validated, meaning any associated policies are run against the snapshot.Valid values:\n\n-   true: Validate the snapshots.\n-   false: Don't validate the snapshots.\n\nData type: Boolean\n\nDefault: false\n\n</td></tr><tr><td>\n\nchangesetNumber\n\n</td><td id=\"changesetNumber-changeset-entry\">\n\nRequired. Unique identifier of the associated changeset, such as \"Chset-10\".\n\nData type: String\n\nTable: CDM Changeset \\[sn\\_cdm\\_changeset\\]\n\n</td></tr><tr><td>\n\npublishOption\n\n</td><td>\n\nPublish option for the associated configured snapshots.\n\nValid values:\n\n-   publish\\_none: Don't publish any snapshots.\n-   publish\\_valid: Publish only those snapshots that pass validation after the commit.\n\nFor additional information on publishing snapshots, see [Publish or unpublish a snapshot](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/it-service-management/cdm-snapshot-publish.md).\n\nData type: String\n\nDefault: publish\\_none\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Header|Description|\n|------|-----------|\n|Accept|Data format of the response body. Only supports **application/json**.|\n|Content-Type|Data format of the request body. Only supports **application/json**.|\n\n|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n<table><thead><tr><th>\n\nStatus code\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\n200\n\n</td><td id=\"entry-200-status-code\">\n\nSuccessful. The request was successfully processed.\n\n</td></tr><tr><td>\n\n400\n\n</td><td>\n\nBad Request. Error: &lt;Error message&gt;Validate that the **changeset\\_id** parameter that you passed in was correct.\n\n Ensure that you have the required roles to access this endpoint.\n\n</td></tr><tr><td>\n\n500\n\n</td><td>\n\nInternal Server Error: Invalid boolean value.If you passed in the **autoValidate** parameter, verify that it is a boolean value.\n\n</td></tr></tbody>\n</table>### Response body parameters\n\n<table id=\"id_cjx_1yy_ztb\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\ncommit\\_id\n\n</td><td>\n\nSys\\_id of the commit request. Use this ID when calling the [CdmChangesetsApi - GET /sn\\_cdm/changesets/commit-status/\\{commit\\_id\\}](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-apis/changesets-api.md) endpoint to check the status of the commit request.\n\nData type: String\n\n</td></tr><tr><td>\n\nerror\n\n</td><td>\n\nIf an error occurred during processing, the details about the error.Data type: Object\n\n```\n\"error\": {\n  \"detail\": \"String\",\n  \"message\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nerror.detail\n\n</td><td>\n\nAdditional information about the error.Data type: String\n\n</td></tr><tr><td>\n\nerror.message\n\n</td><td>\n\nError message that was generated while trying to process the request.Data type: String\n\n</td></tr><tr><td>\n\nstatus\n\n</td><td>\n\nStatus of the commit. Only returned when an error occurs.Possible values: failure\n\nData type: String\n\n</td></tr></tbody>\n</table>### cURL request\n\nThe follow code example shows how to use this endpoint to update a changeset.\n\n```\ncurl \"http://instance.servicenow.com/api/sn_cdm/changesets/commit?changesetNumber=Chset-146\" \\ \n--request PUT \\ \n--header \"Accept:application/json\" \\ \n--user 'username':'password'\n```\n\nReturn results:\n\n```\n{ \n  \"result\": { \n    \"commit_id\": \"cca8190f53141110a1d3ddeeff7b129e\" \n  } \n}\n```\n\n"}}